//
// Created by Attila Haluska on 9/7/18.
//

#ifndef ASPL_C_BYTECODE_ARRAY_H
#define ASPL_C_BYTECODE_ARRAY_H

#include <stddef.h>
#include <stdint.h>

#include "forward_declarations.h"
#include "data_structures/uint8_array.h"
#include "data_structures/uint64_array.h"
#include "data_structures/value_pointer_array.h"

typedef struct bytecode_array_t {
    Uint8Array code;
    Uint64Array lines;
    ValuePointerArray constants;
} BytecodeArray;

extern void bytecode_array_init(BytecodeArray* array);
extern void bytecode_array_free(BytecodeArray* array);
extern void bytecode_array_add_bytecode(BytecodeArray* array, uint8_t byte_code, uint64_t line);
extern uint16_t bytecode_array_add_constant(BytecodeArray* array, Value* value);

#endif //ASPL_C_BYTECODE_ARRAY_H
